//---------------------------------------------------------------- -o--
// GTTestParseOfSection3.java 
// 
// Test error output of parse logic for Section3 of a Galactic Transaction.
//
// 
// HELPER METHODS--
//   generateOutputFileResults
//   tearDown
//
// TEST METHODS--
//   testSection3_a_misformedGN
//

import java.lang.*;
import java.io.*;
import java.util.*;

import junit.framework.*;
import org.junit.*;
import org.apache.commons.io.*;
import org.hamcrest.*;



//----------------------------------------------------------------- -o--
public class GTTestParseOfSection3 extends TestCase
{
  //-------------------------------------------------------------- -o--
  // Helper methods.
  //

  //------------------------------ -o-
  private String  generateOutputFileResults(String inputFileName)
  {
    String  outputFileFullPathname = null;

    File    outputResultsFile  = null;
    String  outputResults      = null;


    try {
      outputFileFullPathname  = GTHelper.setFilesAndRunProgram(inputFileName);
      outputResultsFile       = new File(outputFileFullPathname);

      assertTrue( 
          "Output file EXISTS.  ("+ outputResultsFile.getName() +")", 
          outputResultsFile.exists() );

      outputResults = 
          new String(FileUtils.readFileToString(outputResultsFile, "utf-8"));


    } catch (Exception e) {
      System.err.println("TEST ERROR IN "+ getClass() +": "+ e.toString());
    }


    return outputResults;

  } // generateOutputFileResults()



  //-------------------------------------------------------------- -o--
  // Test methods.
  //

  //------------------------------ -o-
  @After
  protected void  tearDown()
  {
    GalacticNumber.clear();
    MaterialUnit.clear();
  }


  //------------------------------ -o-
  @org.junit.Test
  public void  testSection3_a_misformedGN()
  {
    String  inputFileName  = 
                "section3-shouldFail-a-misformedGN-input.txt";
    String  outputResults  = generateOutputFileResults(inputFileName);


    String   expectedString       = 
                GTHelper.BADINPUT_PREFIX 
		  + "how many Credits is bead evoi zoew Zircon";
    Boolean  foundExpectedString  = 
                GTHelper.stringContains(outputResults, expectedString);


    if (!foundExpectedString) {
      GTHelper.dumpResultsString(outputResults, inputFileName);
    }

    assertTrue( 
      "FOUND expected string '"+ expectedString +"'.", foundExpectedString );

  } // testSection3_a_misformedGN()
	
} // class GTTestParseOfSection3

