//---------------------------------------------------------------- -o--
// PuzzleTest.java 
// 
// TEST METHODS--
//   testEndToEnd
//
//
// @version 0.1 
//

import java.lang.*;
import java.io.*;

import junit.framework.*;
import org.junit.*;
import org.apache.commons.io.*;



//----------------------------------------------------------------- -o--
public class  PuzzleTest extends TestCase 
{
  //------------------------------ -o-
  // testEndToEnd()
  //
  // Based on the input from the problem specification, compare output of
  // Puzzle against output presented in problem specification.
  //
  // DEPENDS upon ant to invoke Puzzle via runexample in build.xml.
  //
  public void testEndToEnd()
  {
    String 
      goldStandardFilename    = GTHelper.TESTFILES_DIR + "example-output.txt",
      previousOutputFilename  = GTHelper.TESTFILESPREV_DIR + "test-output.txt";


    try {
      File goldStandard    = new File(goldStandardFilename);
      File previousOutput  = new File(previousOutputFilename);

      assertTrue("Previous run output file EXISTS.", previousOutput.exists());


      String goldStandardString = 
	new String(FileUtils.readFileToString(goldStandard, "utf-8"));
      String previousOutputString = 
	new String(FileUtils.readFileToString(previousOutput, "utf-8"));

      if (!FileUtils.contentEquals(goldStandard, previousOutput)) {
        System.out.println("\nGOLD STANDARD OUTPUT--\n");
	System.out.println(goldStandardString);

        System.out.println("\nPREVIOUS OUTPUT--\n");
	System.out.println(previousOutputString);
      }


      assertTrue(
	"Gold standard and previous output are EQUAL.",
	FileUtils.contentEquals(goldStandard, previousOutput)
      );


    } catch (Exception e) {
      e.printStackTrace();
      System.err.println(e.toString());
    }

  } // testEndToEnd()
  
} // class PuzzleTest

